import { Collidable } from './collision';
import { Movement } from './line';
import { Point } from './point';

import { vec2 } from 'gl-matrix';

export class Circle implements Collidable, Point {
	private pointCollide = Point.prototype.collide;

	constructor(public readonly p: vec2, public readonly r: number) {}

	public collide(out: vec2, move: Movement, r: number): boolean {
		return this.pointCollide(out, move, r + this.r);
	}
}
