const path = require('path');

module.exports = (env, argv) => {
	let config = {
		entry: './src/index.ts',
		devServer: {
			contentBase: './dist'
		},
		module: {
			rules: [
				{
					test: /\.ts$/,
					use: 'ts-loader',
					exclude: /node_modules/
				},
					{
					test: /\.(vs|fs)$/,
					use: [
					 'raw-loader'
					]
				}
			]
		},
		resolve: {
			extensions: [ ".ts", ".js" ]
		},
		output: {
			filename: 'bundle.js',
			path: path.resolve(__dirname, 'dist')
		},
	};

	if (argv.mode === 'development') {
		config.devtool = 'eval-source-map';
	}

	return config;
};
